// 2007/09/16 Hiroyuki Ogasawara
// vim:ts=4 sw=4:
/*!
	@file
	@date	2007/09/16
	@author	Hiroyuki Ogasawara
	@brief

	@sa http://dench.flatlib.jp/
	@sa http://wlog.flatlib.jp/
*/

#ifndef	__MAIN__H__
#define	__MAIN__H__


#include	<windows.h>
#include	<d3d10.h>
#include	<d3dx10.h>


#define		ZRELEASE( inf )		((inf)?((inf)->Release(),(inf)=NULL):0)


/*!
	@brief
		TvvOp̋ʃR[h
*/
class whSample {
protected:
	IDXGISwapChain*				iSwapChain;
	ID3D10Device*				iDevice;
	ID3D10RenderTargetView*		iRenderTargetView;
	ID3D10DepthStencilView*		iDepthStencilView;
private:
	HWND	hWnd;
private:
	static LRESULT CALLBACK	WindowExec( HWND, UINT mes, WPARAM, LPARAM );
public:
	whSample();
	virtual ~whSample();
	void	InitDevice( int winmode, DWORD width, DWORD height, LPCTSTR title );
	void	ReleaseDevice();
	int		WaitMessage();
};



#endif

